// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/Item.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__ITEM__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__ITEM__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/msg/detail/item__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'rectangle'
#include "rc_reason_msgs/msg/detail/rectangle__traits.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__traits.hpp"

namespace rc_reason_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Item & msg,
  std::ostream & out)
{
  out << "{";
  // member: uuid
  {
    out << "uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.uuid, out);
    out << ", ";
  }

  // member: grasp_uuids
  {
    if (msg.grasp_uuids.size() == 0) {
      out << "grasp_uuids: []";
    } else {
      out << "grasp_uuids: [";
      size_t pending_items = msg.grasp_uuids.size();
      for (auto item : msg.grasp_uuids) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: rectangle
  {
    out << "rectangle: ";
    to_flow_style_yaml(msg.rectangle, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Item & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: uuid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "uuid: ";
    rosidl_generator_traits::value_to_yaml(msg.uuid, out);
    out << "\n";
  }

  // member: grasp_uuids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.grasp_uuids.size() == 0) {
      out << "grasp_uuids: []\n";
    } else {
      out << "grasp_uuids:\n";
      for (auto item : msg.grasp_uuids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: rectangle
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rectangle:\n";
    to_block_style_yaml(msg.rectangle, out, indentation + 2);
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Item & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::msg::Item & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::msg::Item & msg)
{
  return rc_reason_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::msg::Item>()
{
  return "rc_reason_msgs::msg::Item";
}

template<>
inline const char * name<rc_reason_msgs::msg::Item>()
{
  return "rc_reason_msgs/msg/Item";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::Item>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::Item>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::msg::Item>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__ITEM__TRAITS_HPP_
