// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/SilhouetteMatchInstance.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/silhouette_match_instance__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `id`
// Member `object_id`
// Member `pose_frame`
#include "rosidl_runtime_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"

bool
rc_reason_msgs__msg__SilhouetteMatchInstance__init(rc_reason_msgs__msg__SilhouetteMatchInstance * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  // object_id
  if (!rosidl_runtime_c__String__init(&msg->object_id)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  // pose_frame
  if (!rosidl_runtime_c__String__init(&msg->pose_frame)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__SilhouetteMatchInstance__fini(rc_reason_msgs__msg__SilhouetteMatchInstance * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // object_id
  rosidl_runtime_c__String__fini(&msg->object_id);
  // pose_frame
  rosidl_runtime_c__String__fini(&msg->pose_frame);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
}

bool
rc_reason_msgs__msg__SilhouetteMatchInstance__are_equal(const rc_reason_msgs__msg__SilhouetteMatchInstance * lhs, const rc_reason_msgs__msg__SilhouetteMatchInstance * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->timestamp), &(rhs->timestamp)))
  {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // object_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->object_id), &(rhs->object_id)))
  {
    return false;
  }
  // pose_frame
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->pose_frame), &(rhs->pose_frame)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__SilhouetteMatchInstance__copy(
  const rc_reason_msgs__msg__SilhouetteMatchInstance * input,
  rc_reason_msgs__msg__SilhouetteMatchInstance * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->timestamp), &(output->timestamp)))
  {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // object_id
  if (!rosidl_runtime_c__String__copy(
      &(input->object_id), &(output->object_id)))
  {
    return false;
  }
  // pose_frame
  if (!rosidl_runtime_c__String__copy(
      &(input->pose_frame), &(output->pose_frame)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__msg__SilhouetteMatchInstance *
rc_reason_msgs__msg__SilhouetteMatchInstance__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__SilhouetteMatchInstance * msg = (rc_reason_msgs__msg__SilhouetteMatchInstance *)allocator.allocate(sizeof(rc_reason_msgs__msg__SilhouetteMatchInstance), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__SilhouetteMatchInstance));
  bool success = rc_reason_msgs__msg__SilhouetteMatchInstance__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__SilhouetteMatchInstance__destroy(rc_reason_msgs__msg__SilhouetteMatchInstance * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__init(rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__SilhouetteMatchInstance * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__SilhouetteMatchInstance *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__SilhouetteMatchInstance), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__SilhouetteMatchInstance__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__SilhouetteMatchInstance__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__fini(rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__SilhouetteMatchInstance__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence *
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * array = (rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__destroy(rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__are_equal(const rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * lhs, const rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__SilhouetteMatchInstance__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence__copy(
  const rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * input,
  rc_reason_msgs__msg__SilhouetteMatchInstance__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__SilhouetteMatchInstance);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__msg__SilhouetteMatchInstance * data =
      (rc_reason_msgs__msg__SilhouetteMatchInstance *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__SilhouetteMatchInstance__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__SilhouetteMatchInstance__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__SilhouetteMatchInstance__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
