// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/Tag.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__TAG__STRUCT_H_
#define RC_REASON_MSGS__MSG__DETAIL__TAG__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'id'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/Tag in the package rc_reason_msgs.
/**
  * Tag definition
 */
typedef struct rc_reason_msgs__msg__Tag
{
  /// ID of the tag.
  /// For april tags, it is <family>_<tag_id>.
  /// Available april tag families: 16h5, 25h7, 25h9, 36h10, 36h11.
  /// Example: april tag family 25h7, tag id 5: 25h7_5.
  /// For QR codes, it the the data contained in the QR code.
  rosidl_runtime_c__String id;
  /// Side length of the (quadratic) tag.
  double size;
} rc_reason_msgs__msg__Tag;

// Struct for a sequence of rc_reason_msgs__msg__Tag.
typedef struct rc_reason_msgs__msg__Tag__Sequence
{
  rc_reason_msgs__msg__Tag * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__msg__Tag__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__TAG__STRUCT_H_
