// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from rc_reason_msgs:msg/Rectangle.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__RECTANGLE__FUNCTIONS_H_
#define RC_REASON_MSGS__MSG__DETAIL__RECTANGLE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "rc_reason_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "rc_reason_msgs/msg/detail/rectangle__struct.h"

/// Initialize msg/Rectangle message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rc_reason_msgs__msg__Rectangle
 * )) before or use
 * rc_reason_msgs__msg__Rectangle__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
bool
rc_reason_msgs__msg__Rectangle__init(rc_reason_msgs__msg__Rectangle * msg);

/// Finalize msg/Rectangle message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
void
rc_reason_msgs__msg__Rectangle__fini(rc_reason_msgs__msg__Rectangle * msg);

/// Create msg/Rectangle message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rc_reason_msgs__msg__Rectangle__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
rc_reason_msgs__msg__Rectangle *
rc_reason_msgs__msg__Rectangle__create();

/// Destroy msg/Rectangle message.
/**
 * It calls
 * rc_reason_msgs__msg__Rectangle__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
void
rc_reason_msgs__msg__Rectangle__destroy(rc_reason_msgs__msg__Rectangle * msg);

/// Check for msg/Rectangle message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
bool
rc_reason_msgs__msg__Rectangle__are_equal(const rc_reason_msgs__msg__Rectangle * lhs, const rc_reason_msgs__msg__Rectangle * rhs);

/// Copy a msg/Rectangle message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
bool
rc_reason_msgs__msg__Rectangle__copy(
  const rc_reason_msgs__msg__Rectangle * input,
  rc_reason_msgs__msg__Rectangle * output);

/// Initialize array of msg/Rectangle messages.
/**
 * It allocates the memory for the number of elements and calls
 * rc_reason_msgs__msg__Rectangle__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
bool
rc_reason_msgs__msg__Rectangle__Sequence__init(rc_reason_msgs__msg__Rectangle__Sequence * array, size_t size);

/// Finalize array of msg/Rectangle messages.
/**
 * It calls
 * rc_reason_msgs__msg__Rectangle__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
void
rc_reason_msgs__msg__Rectangle__Sequence__fini(rc_reason_msgs__msg__Rectangle__Sequence * array);

/// Create array of msg/Rectangle messages.
/**
 * It allocates the memory for the array and calls
 * rc_reason_msgs__msg__Rectangle__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
rc_reason_msgs__msg__Rectangle__Sequence *
rc_reason_msgs__msg__Rectangle__Sequence__create(size_t size);

/// Destroy array of msg/Rectangle messages.
/**
 * It calls
 * rc_reason_msgs__msg__Rectangle__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
void
rc_reason_msgs__msg__Rectangle__Sequence__destroy(rc_reason_msgs__msg__Rectangle__Sequence * array);

/// Check for msg/Rectangle message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
bool
rc_reason_msgs__msg__Rectangle__Sequence__are_equal(const rc_reason_msgs__msg__Rectangle__Sequence * lhs, const rc_reason_msgs__msg__Rectangle__Sequence * rhs);

/// Copy an array of msg/Rectangle messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_reason_msgs
bool
rc_reason_msgs__msg__Rectangle__Sequence__copy(
  const rc_reason_msgs__msg__Rectangle__Sequence * input,
  rc_reason_msgs__msg__Rectangle__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__RECTANGLE__FUNCTIONS_H_
