// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:srv/DetectTags.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__DETECT_TAGS__TRAITS_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__DETECT_TAGS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/srv/detail/detect_tags__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'tags'
#include "rc_reason_msgs/msg/detail/tag__traits.hpp"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const DetectTags_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: tags
  {
    if (msg.tags.size() == 0) {
      out << "tags: []";
    } else {
      out << "tags: [";
      size_t pending_items = msg.tags.size();
      for (auto item : msg.tags) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: pose_frame
  {
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << ", ";
  }

  // member: robot_pose
  {
    out << "robot_pose: ";
    to_flow_style_yaml(msg.robot_pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DetectTags_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: tags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.tags.size() == 0) {
      out << "tags: []\n";
    } else {
      out << "tags:\n";
      for (auto item : msg.tags) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: pose_frame
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << "\n";
  }

  // member: robot_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_pose:\n";
    to_block_style_yaml(msg.robot_pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DetectTags_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::DetectTags_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::DetectTags_Request & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::DetectTags_Request>()
{
  return "rc_reason_msgs::srv::DetectTags_Request";
}

template<>
inline const char * name<rc_reason_msgs::srv::DetectTags_Request>()
{
  return "rc_reason_msgs/srv/DetectTags_Request";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::DetectTags_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::DetectTags_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::DetectTags_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'tags'
#include "rc_reason_msgs/msg/detail/detected_tag__traits.hpp"
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const DetectTags_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: tags
  {
    if (msg.tags.size() == 0) {
      out << "tags: []";
    } else {
      out << "tags: [";
      size_t pending_items = msg.tags.size();
      for (auto item : msg.tags) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: timestamp
  {
    out << "timestamp: ";
    to_flow_style_yaml(msg.timestamp, out);
    out << ", ";
  }

  // member: return_code
  {
    out << "return_code: ";
    to_flow_style_yaml(msg.return_code, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DetectTags_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: tags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.tags.size() == 0) {
      out << "tags: []\n";
    } else {
      out << "tags:\n";
      for (auto item : msg.tags) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp:\n";
    to_block_style_yaml(msg.timestamp, out, indentation + 2);
  }

  // member: return_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "return_code:\n";
    to_block_style_yaml(msg.return_code, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DetectTags_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::DetectTags_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::DetectTags_Response & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::DetectTags_Response>()
{
  return "rc_reason_msgs::srv::DetectTags_Response";
}

template<>
inline const char * name<rc_reason_msgs::srv::DetectTags_Response>()
{
  return "rc_reason_msgs/srv/DetectTags_Response";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::DetectTags_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::DetectTags_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::DetectTags_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_reason_msgs::srv::DetectTags>()
{
  return "rc_reason_msgs::srv::DetectTags";
}

template<>
inline const char * name<rc_reason_msgs::srv::DetectTags>()
{
  return "rc_reason_msgs/srv/DetectTags";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::DetectTags>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_reason_msgs::srv::DetectTags_Request>::value &&
    has_fixed_size<rc_reason_msgs::srv::DetectTags_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_reason_msgs::srv::DetectTags>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_reason_msgs::srv::DetectTags_Request>::value &&
    has_bounded_size<rc_reason_msgs::srv::DetectTags_Response>::value
  >
{
};

template<>
struct is_service<rc_reason_msgs::srv::DetectTags>
  : std::true_type
{
};

template<>
struct is_service_request<rc_reason_msgs::srv::DetectTags_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_reason_msgs::srv::DetectTags_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__SRV__DETAIL__DETECT_TAGS__TRAITS_HPP_
