// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/GetBasePlaneCalibration.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__GET_BASE_PLANE_CALIBRATION__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__GET_BASE_PLANE_CALIBRATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'pose_frame'
#include "rosidl_runtime_c/string.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in srv/GetBasePlaneCalibration in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__GetBasePlaneCalibration_Request
{
  /// Required. Pose frame for output poses (valid values are camera and external)
  rosidl_runtime_c__String pose_frame;
  /// Required only if sensor is robot-mounted
  geometry_msgs__msg__Pose robot_pose;
} rc_reason_msgs__srv__GetBasePlaneCalibration_Request;

// Struct for a sequence of rc_reason_msgs__srv__GetBasePlaneCalibration_Request.
typedef struct rc_reason_msgs__srv__GetBasePlaneCalibration_Request__Sequence
{
  rc_reason_msgs__srv__GetBasePlaneCalibration_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__GetBasePlaneCalibration_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'pose_frame'
// already included above
// #include "rosidl_runtime_c/string.h"
// Member 'plane'
#include "shape_msgs/msg/detail/plane__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.h"

/// Struct defined in srv/GetBasePlaneCalibration in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__GetBasePlaneCalibration_Response
{
  /// frame in which plane is given
  rosidl_runtime_c__String pose_frame;
  shape_msgs__msg__Plane plane;
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__GetBasePlaneCalibration_Response;

// Struct for a sequence of rc_reason_msgs__srv__GetBasePlaneCalibration_Response.
typedef struct rc_reason_msgs__srv__GetBasePlaneCalibration_Response__Sequence
{
  rc_reason_msgs__srv__GetBasePlaneCalibration_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__GetBasePlaneCalibration_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__GET_BASE_PLANE_CALIBRATION__STRUCT_H_
